package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.params.ElGamalParameters;
import java.math.BigInteger;
import java.security.SecureRandom;

public class ElGamalParametersGenerator {
   private int size;
   private int certainty;
   private SecureRandom random;

   public void init(int size, int certainty, SecureRandom random) {
      this.size = size;
      this.certainty = certainty;
      this.random = random;
   }

   public ElGamalParameters generateParameters() {
      int var1 = this.certainty;
      BigInteger var2;
      BigInteger[] var4;
      BigInteger var10000 = var2 = (var4 = DHParametersHelper.generateSafePrimes(this.size, var1, this.random))[0];
      ElGamalParametersGenerator var10001 = this;
      BigInteger var3 = var4[1];
      var3 = DHParametersHelper.selectGenerator(var10000, var3, var10001.random);
      return new ElGamalParameters(var2, var3);
   }
}
